unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VclTee.TeeGDIPlus,
  VCLTee.Series, VCLTee.TeEngine, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.Buttons, system.UITypes, system.Math;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    LabeledEdit1: TLabeledEdit;
    BitBtn1: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const

//xk[CB(2)AB(4)AB(6)A...AB(16)

  B : array[1..8] of double = ( 1.0 / 6,           // B(2)
                                  -1.0 / 30,
                                   1.0 / 42,
                                  -1.0 / 30,
                                   5.0 / 66,
                                -691.0 / 2730,
                                   7.0 / 6,
                               -3617.0 / 510);         // B(16)

  m: integer = sizeof(B) div sizeof(double);

function logGamma(x: double): double;  // K}֐̑ΐ
var
  i : integer;
  sum : double;
  xx, v  : double;
  xj  : double;
  lng : double;
  ln_sqrt_2pi: double;
begin
  ln_sqrt_2pi := ln(sqrt(2 * pi));                    // = ln(2 * pi) / 2;
  sum := 0;
  v := 1;
	while x < m do begin
    v := v * x;
    x := x + 1;
  end;
  xx := x * x;
  xj := x;
  lng := ln_sqrt_2pi - x + (x - 0.5) * ln(x) - ln(v);
  for i := 1 to  m do begin
    sum := sum + B[i] / (i * 2 * (2 * i - 1)) / xj;
    xj := xj * xx;
  end;
  result := sum + lng;
end;

function q_gamma(a, x, loggamma_a: double): double; forward;

// (a, x, ln(a))
function p_gamma(a, x, loggamma_a: double): double;
var
  k : integer;
  term, previous : double;
begin
  result := 0;
	if x = 0 then exit;
	if x >= 1 + a then begin
    result :=  1 - q_gamma(a, x, loggamma_a);
    exit;
  end;
	term := exp(a * ln(x) - x - loggamma_a) / a;
  result := term;
	for k := 1 to 1000 do begin
		term := term * x / (a + k);
		previous := result;
    result := result + term;
		if result = previous then begin
      exit;
    end;
	end;
	Form1.Memo1.Lines.add ('p_gamma: ܂');
end;

// (a, x, ln(a))
function q_gamma(a, x, loggamma_a: double): double;
var
  k : integer;
  w, temp, previous : double;
  la, lb : double;
begin                 // Laguerrȇ
  la := 1;
  lb := 1 + x - a;
	if x < 1 + a then begin
    result := 1 - p_gamma(a, x, loggamma_a);
    exit;
  end;
	w := exp(a * ln(x) - x - loggamma_a);
	result := w / lb;
	for k := 2  to 1000 do begin
		temp := ((k - 1 - a) * (lb - la) + (k + x) * lb) / k;
		la := lb;
    lb := temp;
		w := w * (k - 1 - a) / k;
		temp := w / (la * lb);
		previous := result;
    result := result + temp;
		if result = previous then exit;
	end;
	Form1.Memo1.Lines.add ('q_gamma: ܂');
end;

function p_chisq(chisq: double; df: integer): double;   // JC2敪z̉m
begin
	result := p_gamma(0.5 * df, 0.5 * chisq, loggamma(0.5 * df));
end;

function q_chisq(chisq: double; df: integer): double;   // JC2敪z̏㑤m
begin
	result := q_gamma(0.5 * df, 0.5 * chisq, loggamma(0.5 * df));
end;

const
  LOG_PI = 1.14472988584940017;

function erf(x: double): double;      // Gausš덷֐
begin
	if x >= 0 then result := p_gamma(0.5, x * x, LOG_PI / 2)
	          else result :=  - p_gamma(0.5, x * x, LOG_PI / 2);
end;

function erfc(x: double): double;     // 1 - erf(x)
begin
	if x >= 0 then  result := q_gamma(0.5, x * x, LOG_PI / 2)
	          else  result := 1 + p_gamma(0.5, x * x, LOG_PI / 2);
end;

function p_normal(x: double): double; // WKz̉m
begin
	if x >= 0 then result := 0.5 * (1 + p_gamma(0.5, 0.5 * x * x, LOG_PI / 2))
	          else result := 0.5 * q_gamma(0.5, 0.5 * x * x, LOG_PI / 2);
end;

function q_normal(x: double): double; // WKz̏㑤m
begin
	if x >= 0 then result := 0.5 * q_gamma(0.5, 0.5 * x * x, LOG_PI / 2)
	          else result := 0.5 * (1 + p_gamma(0.5, 0.5 * x * x, LOG_PI / 2));
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
var
  ch : integer;
  x, xi, y : double;
  k : integer;
  UP, DW  : double;
  MIN, MAX: double;
  dx     : double;
  i : integer;

  // WKzmx ^2 = 1
  function normal(x: double): double;
  begin
    result := exp(- (x * x) / 2) / sqrt(2 * pi);
  end;

begin
  Memo1.Clear;
  val(LabeledEdit1.Text, x, Ch);
  if ch <> 0 then begin
    MessageDlg('x̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  if radiobutton3.Checked then
    if x < 0 then begin
      MessageDlg('x͌vZo܂', mtInformation,
        [mbOk], 0, mbOk);
      exit;
    end;
  val(LabeledEdit2.Text, k, Ch);
  if ch <> 0 then begin
    MessageDlg('k̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  if k <= 0 then begin
    MessageDlg('k̓[傫ĉvZo܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
//  UP := 0;
  DW := 0;
  if radiobutton1.Checked then begin
    UP := q_normal(x);
    DW := p_normal(x);
    Memo1.Lines.Add('WKz');
    Memo1.Lines.Add('^2 = 1');
    y := normal(x);
    Memo1.Lines.Add('mx = ' + floattostr(y));
    Memo1.Lines.Add('m = ' + floatTostr(DW));
    Memo1.Lines.Add('㑤m = ' + floatTostr(UP));
  end;
  if radiobutton2.Checked then begin
    DW := erf(x);
    UP := erfc(x);
    Memo1.Lines.Add('KEX̌덷֐');
    Memo1.Lines.Add('erf  = ' + floatTostr(DW));
    Memo1.Lines.Add('erfc = ' + floatTostr(UP));
  end;
  if radiobutton3.Checked then begin
    y := 1 / (power(2, k / 2) * exp(loggamma(k / 2)));
    UP := power(x, k / 2 - 1);
    DW := exp(-x / 2);
    y := y * UP * DW;
    UP := q_chisq(x, k);
    DW := p_chisq(x, k);
    Memo1.Lines.Add('JCQ敪z');
    Memo1.Lines.Add('mx = ' + floattostr(y));
//    Memo1.Lines.Add('ݐϕz֐@F(' + floatTostr(x) + ';' + intTostr(k) + ')');
    Memo1.Lines.Add('m = ' + floatTostr(DW));
    Memo1.Lines.Add('㑤m = ' + floatTostr(UP));
  end;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  if radiobutton1.Checked then begin
    Min := -5;
    MAX := 5;
    if x > MAX then MAX := x + 1;
    if x < MIN then MIN := x - 1;
    dx := (MAX - MIN) / 400;
    for i := 0 to 400 do begin
      xi := i * dx + MIN;
      y := normal(xi);
      Series1.AddXY(xi, y);
      if x <= xi then begin
        Series2.AddXY(xi, y);
        Series2.AddXY(xi, 0);
        Series2.AddXY(xi, y);
      end;
    end;
  end;
  if radiobutton2.Checked then begin
    Series3.AddXY(x, DW);
    Min := -3;
    MAX := 3;
    if x > MAX then MAX := x + 1;
    if x < MIN then MIN := x - 1;
    dx := (MAX - MIN) / 400;
    for i := 0 to 400 do begin
      xi := i * dx + MIN;
      y := erf(xi);
      Series1.AddXY(xi, y);
    end;
  end;
  if radiobutton3.Checked then begin
    Series4.AddXY(x, DW);
    Min := 0;
    MAX := 3;
    if x > MAX - 1 then MAX := x + 1;
    dx := (MAX - MIN) / 400;
    for i := 0 to 400 do begin
      xi := i * dx + MIN;
      y := p_chisq(xi, k);
      Series2.AddXY(xi, y);
    end;
  end;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  LabeledEdit2.Enabled := False;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  LabeledEdit2.Enabled := False;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
  LabeledEdit2.Enabled := True;
end;

end.
